/*
 * Function.cpp
 *
 *  Created on: 16.02.2013
 *      Author: 
 */

#include "Function.h"

#include <cmath>
#include <cstdio>

/**
 *
 */
void Function::getDiscreteSecondDerivatives(data_t from, data_t to,
		int pointsCount, data_t* out) {
	if (from < to) {
		data_t buf = from;
		from = to;
		to = buf;
	}
	data_t h = (to - from) / (pointsCount - 1);

	//TODO: finish or remove this
}

Function::~Function() {}

void Function::getDiscreteSecondDeriavtivesPeriodical(data_t from, data_t to, int pointsCount, data_t * out) {
	if (from < to) {
		data_t buf = from;
		from = to;
		to = buf;
	}
	data_t h = (to - from) / (pointsCount - 1);

	data_t mul = 1 / (h * h);
	data_t* valuesData = new data_t[pointsCount + 2];
	data_t currentX = from - h;
	for (int i = 0; i < pointsCount + 2; ++i, currentX += h) {
		valuesData[i] = at(currentX);
	}
	for (int i = 0; i < pointsCount; ++i) {
		out[i] = (valuesData[i] - 2 * valuesData[i + 1] + valuesData[i + 2]) * mul;
	}
	delete[] valuesData;
}
/*
FunctionBinOp::FunctionBinOp(Function const * const a, Function const * const b, funBinOpEnum newOp) : first(a), second(b), op(newOp) {
}

data_t FunctionBinOp::at(data_t x) {
	switch (op) {
		case SUM:
			return first->at(x) + second->at(x);
		case SUB:
			return first->at(x) - second->at(x);
		case MUL:
			return first->at(x) * second->at(x);
		case DIV:
			return first->at(x) / second->at(x);
		case COMP:
			return first->at(second->at(x));
	}
}

FunctionUnOp::FunctionUnOp(Function const * const f, data_t arg, funUnOpEnum op) :
		fun(f), scalarArg(arg), opEnum(op) {
}
data_t FunctionUnOp::at(data_t x) {
	switch (opEnum) {
	case ADD_RES_CONST:
		return fun->at(x) + scalarArg;
	case MUL_RES_CONST:
		return fun->at(x) * scalarArg;
	case ADD_ARG_CONST:
		return fun->at(x + scalarArg);
	case MUL_ARG_CONST:
		return fun->at(x * scalarArg);
	case POW_RES_CONST_ARG:
		return pow(fun->at(x), scalarArg);
	case POW_RES_CONST_BASE:
		return pow(scalarArg, fun->at(x));
	case POW_ARG_CONST_ARG:
		return fun->at(pow(x, scalarArg));
	case POW_ARG_CONST_BASE:
		return fun->at(pow(scalarArg, x));
	}
}
*/
//Function const& operator-(Function const& a) {
//	FunctionUnOp res = new FunctionUnOp(a, (data_t)-1, MUL_RES_CONST);
//	return res;
//}

//FunctionBinOp operator+ (Function const &  a, Function const& b) {
//	FunctionBinOp res(a, b, SUM);
//	return res;
//}
//FunctionBinOp operator- (Function const & a, Function const& b) {
//	FunctionBinOp res(a, b, SUB);
//	return res;
//}
//FunctionBinOp operator* (Function const & a, Function const& b) {
//	FunctionBinOp res(a, b, MUL);
//	return res;
//}
//FunctionBinOp operator/ (Function const& a, Function const& b) {
//	FunctionBinOp res(a,b,DIV);
//	return res;
//}
//FunctionUnOp operator+ (Function const& a, data_t const& b) {
//	FunctionUnOp res(a, b, ADD_RES_CONST);
//	return res;
//}
//FunctionUnOp operator- (Function const& a, data_t const& b) {
//	FunctionUnOp res(a, -b, ADD_RES_CONST);
//	return res;
//}
//FunctionUnOp operator/ (Function const& a, data_t const& b) {
//	FunctionUnOp res(a, 1 / b, MUL_RES_CONST);
//	return res;
//}
//FunctionUnOp operator* (Function const& a, data_t const& b) {
//	FunctionUnOp res(a, b, MUL_RES_CONST);
//	return res;
//}
//FunctionUnOp operator+ (data_t const a, Function const& b) {
//	return b + a;
//}
//FunctionUnOp operator- (data_t const a, Function const& b) {
//	return (-(b - a));
//}
//FunctionUnOp operator/ (data_t const a, Function const& b) {
//	return 1 / (b / a);
//}
//FunctionUnOp operator* (data_t const a, Function const& b) {
//	return b * a;
//}


